<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no"
    />

    <title>AuRa - Overview and Roadmap to the Automated Radio Project</title>

    <link rel="stylesheet" href="reveal.js/dist/reset.css" />
    <link rel="stylesheet" href="reveal.js/dist/reveal.css" />
    <link rel="stylesheet" href="reveal.js/dist/theme/black.css" id="theme" />

    <!-- Theme used for syntax highlighted code -->
    <link
      rel="stylesheet"
      href="plugin/highlight/zenburn.css"
      id="highlight-theme"
    />

    <!-- our local modifications -->
    <link rel="stylesheet" href="local.css" />
  </head>

  <body>
    <div class="reveal">
      <div class="slides">
        <!--
        Note on markdown page breaks:
        According to https://revealjs.com/markdown/ it should be possible to
        write all pages in one consecutive section/textarea segment, but no matter
        how I configured it, the page break does not work. Therefore I am using
        individual section/textarea segments.
        -->

        <section data-markdown>
          <textarea data-template>
            <div style="float: left;">
              <img data-src="imgs/aura-logo.png" width="150px" style="transform: rotate(-5deg); margin-bottom: 5em;">
            </div>

            ## Overview and Roadmap to the <span class="hl">Au</span>tomated <span class="hl">Ra</span>dio Project

            @ [danube streamwaves digital](https://www.freefm.de/projekte/danubestreamwaves-digital)

            jackie / Andrea Ida Malkah Klaura &lt;<a href="mailto:jackie@diebin.at">jackie@diebin.at</a>&gt;<br>
            David Trattnig &lt;<a href="mailto:david.trattnig@o94.at">david.trattnig@o94.at</a>&gt;

            <small>
              the internet, 11. November 2020<br><br>

              This presentation and its [source code](https://gitlab.servus.at/aura/aura/-/blob/main/presentations/zwcm2020)
              are available under a [AGPLv3](https://gitlab.servus.at/aura/aura/-/blob/main/LICENSE)
              license. It builds on the presentation framework [reveal.js](https://revealjs.com),
              which is available under a [MIT](https://github.com/hakimel/reveal.js/blob/main/LICENSE)
              license.
            </small>

            <br><small>_(hit space for next slide, or click on the arrow key in the bottom right corner)_</small>
          </textarea>
        </section>

        <section data-markdown>
          <textarea data-template>
            # 90min roadmap

            - AuRa to make radio - <b class="hl">what it does</b>
            - AuRa as a software project - <b class="hl">how it goes</b>
            - AuRa as a software architecture - <b class="hl">where it runs</b>
            - Q&A and visual insights - <b class="hl">how it looks</b>
          </textarea>
        </section>

        <!-- AuRa zum Radiomachen - was kanns? -->
        <section>
          <section data-markdown>
            <textarea data-template>
              # AuRa to make radio
              ## <b class="hl">what it does</b>
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              <img data-src="imgs/dashboard-user-shows.png" width="70%">
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              <img data-src="imgs/dashboard-user-files.png" width="70%">
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              <img data-src="imgs/dashboard-admin-shows.png" width="70%">
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              <img data-src="imgs/dashboard-admin-create-show.png" width="70%">
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              <img data-src="imgs/dashboard-admin-calendar.png" width="70%">
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              ## AuRa users
              - <!-- .element: class="fragment" data-fragment-index="1" --> <b class="hl">radio makers/hosts | show producers (RM)</b>
                - manage their own shows:
                  - upload of preproduced emissions
                  - create and manage playlists
                  - describe single emissions
              - <!-- .element: class="fragment" data-fragment-index="2" --> <b class="hl">programme coordinators (PC)</b>
                - manage all series/shows:
                  - create new series
                  - create new schedules and emission timeslots
                  - create and assign new radio maker accounts
                  - edit metadata of series
                  - deactivate old series
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              ## AuRa users (indirect)
              - <!-- .element: class="fragment" data-fragment-index="1" --> <b class="hl">people in the studio</b>
                - watch the studio clock
              - <!-- .element: class="fragment" data-fragment-index="2" --> <b class="hl">website visitors</b> and <b class="hl">listeners</b>
                - want to know what is currently on air
                - want to know what was and will be on air
                - want infos on series / shows and single emissions
                - want to hear the live stream or archived emissions
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              ## Interface requirements
              - <!-- .element: class="fragment" data-fragment-index="1" --> ideally everything from one place
              - <!-- .element: class="fragment" data-fragment-index="2" --> but independent of space
              - <!-- .element: class="fragment" data-fragment-index="3" --> mobile ready
              - <!-- .element: class="fragment" data-fragment-index="4" --> adaptable towards own needs
              - <!-- .element: class="fragment" data-fragment-index="5" --> same interface for RM and PC
                - but more capabilities for PCs
              - <!-- .element: class="fragment" data-fragment-index="6" --> integrate external work flows (e.g. CBA)
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              ## What AuRa also should be able to do
              - Cut & Glue of archived emissions
              - Manage jingles (for the station and for series)
              - Dynamic playlists (e.g. music pools)
              - Automated rescheduling of past emissions
              - Automated scheduling of external shows
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              ## What AuRa does not (yet?) do
              - Live studio mixing
              - Live studio info -> trackservice
              - Coffee
            </textarea>
          </section>
        </section>

        <!--  AuRa als Softwareprojekt - wie läufts? -->
        <section>
          <section data-markdown>
            <textarea data-template>
              # AuRa as a software project
              ## <b class="hl">how it goes</b>
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              ## “free” as in “free speech”,<br>not as in “free beer”
              <small>(source: <a href="https://www.gnu.org/philosophy/free-sw.html">https://www.gnu.org/philosophy/free-sw.html</a>)</small>
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              ## Starting basis
              ### at ORANGE 94.0 (Wien)
              - <!-- .element: class="fragment" data-fragment-index="1" --> ~ 450 radio hosts with 198 shows/series
              - <!-- .element: class="fragment" data-fragment-index="2" --> An outdated and unmaintainbale playout system (YARM)
              - <!-- .element: class="fragment" data-fragment-index="3" --> A programme scheduling system based on OpenACS (which is written in TCL and runs on a AolServer4, if you can believe it ;))
              - <!-- .element: class="fragment" data-fragment-index="4" --> An outdated website with a load of unmaintained script patchwork
              - <!-- .element: class="fragment" data-fragment-index="5" --> Many many bash and PHP scripts between and around it
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              ## Starting basis
              ### at the project partners
              - <!-- .element: class="fragment" data-fragment-index="1" --> FRO (Linz): Playout with YARM, already critical, ~ 280 RM
              - <!-- .element: class="fragment" data-fragment-index="2" --> FRF (Freistadt): formerly YARM, now Airtime, > 100 RM, 70 series
              - <!-- .element: class="fragment" data-fragment-index="3" --> Helsinki (Graz): Rivendell, developed their own programme scheduler (which AuRa steering builds on), > 220 RM
              - <!-- .element: class="fragment" data-fragment-index="4" --> Radiofabrik (Salzburg): Playout with YARM, still (!) running ok, > 350 RM, 204 series, ~8.5 hours new programme / day

              <small>Status Nov. 2020, stats taken from the station websites</small>
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              ## Example ORANGE 94.0
              <img data-src="imgs/currentsetup.jpg" width="85%">
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              ## "It's dangerous to go alone!"
              ### why <b class="hl">Y</b>et <b class="hl">A</b>nother <b class="hl">R</b>adio <b class="hl">M</b>anager?
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              ## Y.A.R.M.
              - <!-- .element: class="fragment" data-fragment-index="1" --> Java based playout system
              - <!-- .element: class="fragment" data-fragment-index="2" --> Developed 2004 at the Radiofabrik Salzburg
              - <!-- .element: class="fragment" data-fragment-index="3" --> Adopted by several other free radio stations
              - <!-- .element: class="fragment" data-fragment-index="4" --> In the meantime outdated and unmaintained
              - <!-- .element: class="fragment" data-fragment-index="5" --> Developed mainly by one person, full open sourcing did not work

              <small>[Y.A.R.M. in the web archive of Radiofabrik](https://radiofabrik.at/organisation/projekte/abgeschlossene-projekte/y-a-r-m-2004-2014/)</small>
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              ## Initiative for AuRa
              - <!-- .element: class="fragment" data-fragment-index="1" --> Radiofabrik, Radio FRO, Freies Radio Freistadt, and ORANGE 94.0 all still depended on YARM (at the time)
              - <!-- .element: class="fragment" data-fragment-index="2" --> Urgent need for something new, extensible and maintainable
              - <!-- .element: class="fragment" data-fragment-index="3" --> Survey of over 50 software projects (F/LOSS as well as proprietary and commercial):
                - No existing software fulfills all our requirements sufficiently
              - <!-- .element: class="fragment" data-fragment-index="4" --> Radio Helsinki (Graz) has already developed a quite usable programme scheduler ("PV") building on the Django framework (https://git.helsinki.at/)
              - <!-- .element: class="fragment" data-fragment-index="5" --> Michael Liebler (Radio Z, Nürnberg) has developed a playout system with Python (https://gitlab.janguo.de/groups/comba)
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              ## <b class="hl">Arrr!</b> On t' new shores! <b class="hl">(2017)</b>
              - <!-- .element: class="fragment" data-fragment-index="1" --> We <span class="hl">are pooling our resources</span>:
                - FRO, FRF, ORANGE and Radiofabrik, as well as Helsinki provide money and developer time, respectively
                - 4 Core developers (2x FRO, 1x Helsinki, 1x ORANGE)
                - overall ~ 1 to 1.5 full-time equivalent of developer time
              - <!-- .element: class="fragment" data-fragment-index="2" --> We <span class="hl">build upon existing projects</span>:
                - <!-- .element: class="fragment" data-fragment-index="3" --> Helsinki programme scheduler in Django (Python)
                - <!-- .element: class="fragment" data-fragment-index="4" --> Python-based playout inspired by COMBA
                - <!-- .element: class="fragment" data-fragment-index="5" --> Incorporation of a common set of requirements shared by <span class="hl">several radio stations</span>
                - <!-- .element: class="fragment" data-fragment-index="6" --> <span class="hl">Extensive planning</span> of architecture &amp; APIs <b>BEFORE starting the implementation</b>
                - <!-- .element: class="fragment" data-fragment-index="7" --> We develop <span class="hl">from the start publically and as free software</span>
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              ## Current status
              ### Components
              - <!-- .element: class="fragment" data-fragment-index="1" --> <b class="hl">steering</b> (= programme schedule): fork of the Helsinki PV
              - <!-- .element: class="fragment" data-fragment-index="2" --> <b class="hl">engine</b> (= playout): originally based on COMBA, but for the most part rewritten and reduced
              - <!-- .element: class="fragment" data-fragment-index="3" --> <b class="hl">tank</b> (= importer): based on a component developed for Helsinki and adapted for AuRa
              - <!-- .element: class="fragment" data-fragment-index="4" --> <b class="hl">dashboard</b> (= UI): newly developed for AuRa (see earlier screenshots)
              - <!-- .element: class="fragment" data-fragment-index="5" --> <b class="hl">battery</b> (= recording archive/manager): in planning

              <img data-src="imgs/meta-repo-components.png" width="70%">
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              ## Current status
              ### Team
              - 5 Core developers (2x ORANGE, 2x Helsinki, 1x Radiofabrik)
              - 1 project lead
              - 1 UI tester and GFX contributor

              <img data-src="imgs/credits.png">
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              ## Current status
              ### Work packages
              - 122 open issues
              - 110 closed issues
              - 20 epic issues
              - for AuRa 1.0:
                - 49 open issues (7 epics)
              - for AuRa 1.1:
                - 30 open issues (6 epics)

              <img data-src="imgs/issues.png">
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              ## Current challenges
              - <!-- .element: class="fragment" data-fragment-index="1" --> No clear maintainer roles and capacities
              - <!-- .element: class="fragment" data-fragment-index="2" --> Requirements start to become unclear, forgotten or suddenly arise newly or out of nowhere
              - <!-- .element: class="fragment" data-fragment-index="3" --> 20 hours per week per component, with sustainbale commitment, would actually be a minimum
                - currently we have 2 thereof (the two newest core devs)
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              ## Current project schedule
              - January 2021: Complete API specs
              - February 2021: Start of the "playout" test phase (AuRa 1.0)
              - July 2021: Start of the "high availability" test phase (AuRa 1.1)

              <img data-src="imgs/projectplanning.png">
            </textarea>
          </section>
        </section>

        <!--  AuRa als Architektur - wo läufts? -->
        <section>
          <section data-markdown>
            <textarea data-template>
              # AuRa as a software architecture
              ## <b class="hl">where it runs</b>
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              ## <b class="hl">au</b>to<b class="hl">ra</b>dio
              - https://gitlab.servus.at/autoradio
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              ## technical organisational requirements:
              - <!-- .element: class="fragment" data-fragment-index="1" --> Modular approach, every component should be replaceable
              - <!-- .element: class="fragment" data-fragment-index="2" --> Transparent and well documented interfaces, implemented as REST APIs
              - <!-- .element: class="fragment" data-fragment-index="3" --> Build on existing solutions, which are already in use in free radio stations
              - <!-- .element: class="fragment" data-fragment-index="4" --> Use of established development frameworks
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              ## AuRa data model
              <img data-src="imgs/aura-data-model-simple.png">
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              ## AuRa components
              - <!-- .element: class="fragment" data-fragment-index="1" --><b class="hl">dashboard</b> (Javascript, Vue.js)
              - <!-- .element: class="fragment" data-fragment-index="2" --><b class="hl">steering</b> (Python, Django)
              - <!-- .element: class="fragment" data-fragment-index="3" --><b class="hl">engine</b> (Python & Liquidsoap)
              - <!-- .element: class="fragment" data-fragment-index="4" --><b class="hl">tank</b> (Go)
              - <!-- .element: class="fragment" data-fragment-index="5" --><b class="hl">battery</b> (Python)
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              ## Original architectural model
              <img data-src="imgs/components.png">
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              ## Current architectural model
              - as simple as possible, realisable with two machines (theoretically also on one)
              - alternatively as a redundant HA variant
              - [aura-network-diagram-0.6.pdf](imgs/aura-network-diagram-0.6.pdf)
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              <img data-src="imgs/aura-network-single.png">
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              <img data-src="imgs/aura-network-redundant.png">
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              ## Setup
              - <!-- .element: class="fragment" data-fragment-index="1" --> currently not yet trivial, and not recommendable without Linux admin skills
              - <!-- .element: class="fragment" data-fragment-index="2" --> some components are already containerised
              - <!-- .element: class="fragment" data-fragment-index="3" --> goal is a fully/mostly containerised setup (with Docker)
              - <!-- .element: class="fragment" data-fragment-index="4" --> setup procedure should ideally be reducible to:
                - pull repositories
                - set global environment variables
                - start services via script (or directly with docker-compose)
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              ## Contributions
              - <!-- .element: class="fragment" data-fragment-index="1" --> for bigger contribs we should have maintainers first
              - <!-- .element: class="fragment" data-fragment-index="2" --> always happy about simple bug fixes
              - <!-- .element: class="fragment" data-fragment-index="3" --> our own GitLab instance
                - in this case a bit of a hurdle
                - but we can talk about accounts
              - <!-- .element: class="fragment" data-fragment-index="4" --> easiest are documentation contributions
                - but we should have a common standard/format
              - <!-- .element: class="fragment" data-fragment-index="5" --> localisations can already be created and can be outsourced easily
            </textarea>
          </section>
        </section>

        <section data-markdown>
          <textarea data-template>
            # Infos, resources and channels
            - <!-- .element: class="fragment" data-fragment-index="1" --> GitLab: <a href="https://gitlab.servus.at/aura/">https://gitlab.servus.at/aura/</a>
              - esp. the <b class="hl">meta</b> repo with infos for a first overview and with docs
              - as well as this presentation
            - <!-- .element: class="fragment" data-fragment-index="2" --> AuRa users mailinglist: <a href="https://mailman.o94.at/mailman/admin/aura-users">https://mailman.o94.at/mailman/admin/aura-users</a>
            - <!-- .element: class="fragment" data-fragment-index="3" --> AuRa test instance: <a href="https://aura-test.o94.at/">https://aura-test.o94.at/</a> (write us for accounts)
            - <!-- .element: class="fragment" data-fragment-index="4" --> API definitions: <a href="https://gitlab.servus.at/aura/aura/-/blob/main/docs/development/api-definition.md">https://gitlab.servus.at/aura/aura/-/blob/main/docs/development/api-definition.md</a>
            - <!-- .element: class="fragment" data-fragment-index="4" --> Engine API spec: <a href="https://app.swaggerhub.com/apis/AURA-Engine/engine-api">https://app.swaggerhub.com/apis/AURA-Engine/engine-api</a>
            - <!-- .element: class="fragment" data-fragment-index="5" --> Mattermost (currently only internal)
          </textarea>
        </section>

        <section data-markdown>
          <textarea data-template>
            # <b class="hl">Q</b> & <b class="hl">A</b>

            - Which questions do you have?
            - What do you want to see?
          </textarea>
        </section>

        <section data-markdown>
          <textarea data-template>
            <div style="float: left;">
              <img data-src="imgs/aura-logo.png" width="150px" style="transform: rotate(-5deg); margin-bottom: 5em;">
            </div>

            ## Overview and Roadmap to the <span class="hl">Au</span>tomated <span class="hl">Ra</span>dio Project

            @ [danube streamwaves digital](https://www.freefm.de/projekte/danubestreamwaves-digital)

            jackie / Andrea Ida Malkah Klaura &lt;<a href="mailto:jackie@diebin.at">jackie@diebin.at</a>&gt;<br>
            David Trattnig &lt;<a href="mailto:david.trattnig@o94.at">david.trattnig@o94.at</a>&gt;

            <small>
              the internet, 11. November 2020<br><br>

              This presentation and its [source code](https://gitlab.servus.at/aura/aura/-/blob/main/presentations/zwcm2020)
              are available under a [AGPLv3](https://gitlab.servus.at/aura/aura/-/blob/main/LICENSE)
              license. It builds on the presentation framework [reveal.js](https://revealjs.com),
              which is available under a [MIT](https://github.com/hakimel/reveal.js/blob/main/LICENSE)
              license.
            </small>
          </textarea>
        </section>
      </div>
    </div>

    <script src="reveal.js/dist/reveal.js"></script>
    <script src="reveal.js/plugin/notes/notes.js"></script>
    <script src="reveal.js/plugin/markdown/markdown.js"></script>
    <script src="reveal.js/plugin/highlight/highlight.js"></script>
    <script src="reveal.js/plugin/zoom/zoom.js"></script>
    <script>
      // More info about initialization & config:
      // - https://revealjs.com/initialization/
      // - https://revealjs.com/config/
      Reveal.initialize({
        hash: true,

        // Learn about plugins: https://revealjs.com/plugins/
        plugins: [RevealMarkdown, RevealHighlight, RevealNotes, RevealZoom],
      })
    </script>
  </body>
</html>
